<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: albums.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
 
// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * This is album controller for component. It contain some methods to manage album
 *
 * @category   Controller
 * @author     Pham Thanh Binh <binhpham@netq.vn>
 */
class QGalleryControllerPictures extends QController
{
	/**
	 * Display default page
	 *
	 * @return void
	 */
	public function display ()
	{
		parent::display();
	}
	
	/**
	 * Update information for picture
	 *
	 * @return void
	 */
	public function update ()
	{
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'file.php';
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'image.php';
		
		$path = JPATH_SITE.DS.'images'.DS.'com_qgallery';
		if (!is_dir($path)) {
			mkdir($path);
		}
		
		// Upload file to server
		$file = FileHelper::getUploadedFiles('picture_file', array(
			'allow' => 'jpg, png, gif',
			'randomName' => true,
			'path' => $path
		));

		// Preparing parameter for update to database
		$params = JRequest::get('post');
		$params['picture']['file'] = array_shift($file['picture_file']);
		
		if (!empty($params['picture']['file']) && is_file($path.DS.$params['picture']['file'])) 
		{
			$params['picture']['src'] = sprintf('%simages/com_qgallery/%s', JURI::root(), $params['picture']['file']);
			$params['picture']['src_small'] = sprintf('%simages/com_qgallery/x-%s', JURI::root(), $params['picture']['file']);
			
			// Create thumbnail
			ImageHelper::resize($params['picture']['file'], $path, array(
				'max-width' => 130,
				'max-height' => 150
			));
		}
		
		$table = JTable::getInstance('Pictures', 'Table');
		if (!empty($params['picture']['id'])) {
			$table->load($params['picture']['id']);
			
			if (is_file($path.DS.$table->file)) {
				@unlink($path.DS.$table->file);
				@unlink($path.DS.'x-'.$table->file);
			}
		}
		
		$table->bind($params['picture']);
		if (!$table->store()) {
			$message = 'Cannot update picture information';
			$this->setRedirect('index.php?option=com_qgallery&controller=albums&task=pictures&album='.$table->album_id, $message, 'warning');
		}
		else 
		{
			$album = JTable::getInstance('Albums', 'Table');
			$album->load($table->album_id);
			$message = 'Picture information has been updated';
			$this->setRedirect('index.php?option=com_qgallery&controller=albums&task=pictures&album='.$table->album_id, $message);
		}
	}
	
	/**
	 * Return information of picture as json object to edit in browser
	 *
	 * @return void
	 */
	public function info ()
	{
		$id = JRequest::getInt('id');
		if ($id <= 0) {
			echo "{error: 'Invalid picture ID'}";
			return;
		}
		
		parent::display();
	}
	
	/**
	 * Remove picture in album
	 *
	 * @return void
	 */
	public function remove () 
	{
		try {
			// Retrieve selected album from request
			$cid = JRequest::getVar('cid');
			$album = JRequest::getVar('aid');
			
			// Redirect to album list when error
			if (!is_array($cid)) {
				$this->setRedirect('index.php?option=com_qgallery&controller=albums&task=pictures&album='.$album, 'Invalid album ID');
				return;
			}
			
			$model = JModel::getInstance('Pictures', 'QGalleryModel');
			list($deleted, $skipped) = $model->remove($cid);
			
			$message = sprintf("Total %d pictures has been deleted and %d pictures skipped", $deleted, $skipped);
			$this->setRedirect('index.php?option=com_qgallery&controller=albums&task=pictures&album='.$album, $message);
		}
		catch (Exception $ex) {
			$this->setRedirect('index.php?option=com_qgallery&controller=albums&task=pictures&album='.$album, $ex->getMessage());
		}
	}
}





