<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: facebook.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
 
// No direct access
defined('_JEXEC') or die('Restricted access');

if (!class_exists('Facebook')) {
	require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'libraries'.DS.'api'.DS.'facebook.php';
}

class FacebookHelper
{
	private static $_client = null;
	
	/**
	 * Retrieve facebook client instance to call API request.
	 * This method will return a instance of Facebook class
	 *
	 * @return Facebook
	 */
	public static function getFacebookClient ()
	{
		if (self::$_client == null) {
			$client = new Facebook(array(
			  'appId'  => '162336400466792',
			  'secret' => '44c30b08ff447cba23abcee9bc7b7142',
			  'cookie' => true,
			));
			
			// Get session information from setting
			$session = unserialize(SettingHelper::get('facebook'));
			$session['expires'] = 0;
			
			// Set authenticated session
			$client->setSession($session);
		}
		// Return client instance
		return $client;
	}
	
	/**
	 * Retrieve all album from facebook
	 *
	 * @return array
	 */
	public static function getAlbums ()
	{
		try {
			$client = self::getFacebookClient();
			return $client->api(array('method' => 'photos.getAlbums'));
		}
		catch (Exception $ex) {
			return array();
		}
	}
	
	/**
	 * Retrieve album from facebook by album ID
	 *
	 * @return array
	 */
	public static function getAlbumById ($aid)
	{
		try {
			$client = self::getFacebookClient();
			$albums = $client->api(array('method' => 'photos.getAlbums', 'aids' => $aid));
			
			return (count($albums) > 0) ? array_shift($albums) : null;
		}
		catch (Exception $ex) {
			return array();
		}
	}
	
	/**
	 * Retrieve all pictures from album
	 *
	 * @param string $aid
	 * @return array
	 */
	public static function getPicturesFromAlbum ($aid)
	{
		try {
			$client = self::getFacebookClient();
			return $client->api(array('method' => 'photos.get', 'aid' => $aid));
		}
		catch (Exception $ex) {
			return array();
		}
	}
	
	/**
	 * Upload photo to facebook album
	 *
	 * @param string $file
	 * @param string $caption
	 * @param string $aid
	 */
	public static function uploadPhoto ($file, $caption, $aid)
	{
		try {
			$path = JPATH_SITE.DS.'images'.DS.'com_qgallery'.DS;
			
			$client = self::getFacebookClient();
			$client->setFileUploadSupport(true);
			$client->api(array(
				'method' => 'photos.upload',
				'aid' => $aid,
				'caption' => $caption,
				$file => "@{$path}{$file}"
			));
		}
		catch (Exception $ex) {
		}
	}
	
	/**
	 * Retrieve login url through facebook to get session key
	 *
	 * @param string $return
	 * @return string
	 */
	public static function getLoginUrl ($return)
	{
		$permission = array();
		$permission[] = 'offline_access';
		$permission[] = 'user_groups';
		$permission[] = 'user_photos';
		$permission[] = 'user_videos';
		$permission[] = 'user_photo_video_tags';
		$permission[] = 'publish_stream';
		
		$client = self::getFacebookClient();
		$returnUrl = 'http://apps.netqcreative.com/social-gallery/auth.php?return='.base64_encode($return);
		
		return $client->getLoginUrl(array(
			'req_perms'  => implode(',', $permission),
			'cancel_url' => $returnUrl,
			'next'       => $returnUrl
		));
	}
}