<?php
defined('_JEXEC') or die('Restricted access');

/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: file.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
 
// Load string helper
require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'string.php';

final class FileHelper
{
	/**
	 * Get uploaded file field
	 *
	 * This method will help for retrieve uploaded
	 *
	 * @param string $field
	 * @return mixed
	 */
	private static function _getUploadedFileField ($field)
	{
		if (!isset($_FILES[$field])) {
			return array();
		}

		// This variable will store uploaded file information
		$uploadedFiles = array();
				
		// If is single file upload
		if (!is_array($_FILES[$field]['error'])) {
			$uploadedFiles[] = $_FILES[$field];
		}
		// For multiple files upload
		else {
			$length = count($_FILES[$field]['error']);
			$keys = array_keys($_FILES[$field]);
			
			while (count($uploadedFiles) < $length) 
			{
				$index = count($uploadedFiles);
				$uploadedFiles[$index] = array();
				
				foreach ($keys as $key) {
					$uploadedFiles[$index][$key] = $_FILES[$field][$key][$index];
				}
			}
		}
		
		return $uploadedFiles;
	}
	
	/**
	 * Get uploaded files
	 *
	 * This method will help to move uploaded file from temporary directory 
	 * to folder provided from options parameters
	 * 
	 * @param string $field
	 * @param mixed $options
	 */
	public static function getUploadedFiles ($field, $options = array())
	{
		if (!isset($options['allow'])) $options['allow'] = array();
		if (!isset($options['maxSize']) || !is_numeric($options['maxSize'])) $options['maxSize'] = -1;
		if (!isset($options['randomName'])) $options['randomName'] = false;
		
		// When allow option is a string, convert it to array
		if (!is_array($options['allow']) && !empty($options['allow'])) 
		{
			$options['allow'] = explode(',', $options['allow']);
			$options['allow'] = array_map('trim', $options['allow']);
			$options['allow'] = array_map('strtolower', $options['allow']);
		}
		
		// Return empty array when no files are uploaded
		if (!isset($_FILES[$field])) {
			return array();
		}
		
		if (!isset($options['path']) || !is_dir($options['path'])) {
			return array();
		}
		
		$files = self::_getUploadedFileField($field);
		$uploadedFiles = array();
		
		foreach ($files as $file) 
		{
			if ($file['error'] != UPLOAD_ERR_OK) { continue; }
			
			$info = pathinfo($file['name']);
			
			$isAllowedExtension = (!empty($options['allow'])) ? in_array($info['extension'], $options['allow']) : true;
			$isAllowedMaxSize   = ($options['maxSize'] > 0) ? ($options['maxSize'] >= $file['size']) : true;
			$isAllowed = $isAllowedExtension && $isAllowedMaxSize;
			
			if (true === $options['randomName']) {
				$file['name'] = StringHelper::getRandom(32).'.'.$info['extension'];
			}
			
			if (true === $isAllowed && move_uploaded_file($file['tmp_name'], $options['path'].DS.$file['name'])) {
				$uploadedFiles[] = $file['name'];
			}
		}

		return array($field => $uploadedFiles);
	}
}
