<?php
defined('_JEXEC') or die('Restricted access');

/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: image.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

final class ImageHelper
{
	public static function resize ($fileName, $path, $options = array())
	{
		$filePath = $path.DS.$fileName;
		if (!is_file($filePath)) return false;
		if (!is_dir($path)) return false;
		if (!preg_match('/\.(png|gif|jpg)$/i', $fileName)) return false;
		
		
		$originalOptions = array(
			'max-width' => 50,
			'max-height' => 50,
			'save-path' => $path,
			'prefix' => 'x-',
			'suffix' => ''
		);

		$newOptions = array();
		foreach ($originalOptions as $key => $val) {
			$newOptions[$key] = (isset($options[$key])) ? $options[$key] : $val;
		}
		$options = $newOptions;

		$fileInfo = pathInfo($fileName);
		$fileExtension = $fileInfo['extension'];
		$loadImageFuncs = array(
			'png' => 'imageCreateFromPNG',
			'jpg' => 'imageCreateFromJPEG',
			'gif' => 'imageCreateFromGIF'
		);
		
		$image = $loadImageFuncs[$fileExtension]($filePath);
		$imageWidth = imagesx($image);
		$imageHeight = imagesy($image);
		$imageRatio = $imageWidth / $imageHeight;
		
		$thumbWidth = $options['max-width'];
		$thumbHeight = $thumbWidth / $imageRatio;
		
		$thumbImage = imageCreateTrueColor($thumbWidth, $thumbHeight);
		
		imagefill($thumbImage, 0, 0, imagecolorallocate($image, 255, 255, 255));
		imagecopyresampled($thumbImage, $image, 0, 0, 0, 0, $thumbWidth, $thumbHeight, $imageWidth, $imageHeight);
		
		switch($fileExtension) {
			case 'png': 
				imagepng($thumbImage, $path.DS.$options['prefix'].$fileInfo['filename'].$options['suffix'].'.'.$fileExtension);
			break;
			case 'gif': 
				imagegif($thumbImage, $path.DS.$options['prefix'].$fileInfo['filename'].$options['suffix'].'.'.$fileExtension);
			break;
			case 'jpg': 
				imagejpeg($thumbImage, $path.DS.$options['prefix'].$fileInfo['filename'].$options['suffix'].'.'.$fileExtension, 100);
			break;
		}
		
		return true;
	}
}

