<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: setting.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
 
// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * This is helper class named SettingHelper. 
 * This class contain some function to manipulate setting e.g get, set, save.
 * All functions in this class is static, it mean can 
 * call it without create instance of class
 *
 * @category   Helper
 * @author     Pham Thanh Binh <binhpham@netq.vn>
 */
class SettingHelper
{
	private static $_settings = array();
	
	private static function _load ()
	{
		$db = JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__sg_settings");
		$settings = $db->loadObjectList();
		
		foreach ($settings as $setting) {
			self::$_settings[$setting->key] = $setting->value;
		}
	}
	
	public static function get ($key)
	{
		if (empty(self::$_settings)) {
			self::_load();
		}
		
		return (isset(self::$_settings[$key])) ? self::$_settings[$key] : null;
	}
	
	public static function set ($key, $value)
	{
		if (empty(self::$_settings)) {
			self::_load();
		}
		
		self::$_settings[$key] = $value;
	}
	
	public static function save () 
	{
		$db = JFactory::getDBO();

		foreach (self::$_settings as $key => $value) {
			$db->setQuery("REPLACE #__sg_settings SET `key`='{$key}', `value`='{$value}'");
			$db->query();
		}
	}
}