<?php
defined('_JEXEC') or die('Restricted access');

/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: string.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

final class StringHelper
{
	/**
	 * Convert vietnamese string to ascii string
	 *
	 * @param string $str
	 * @return string
	 */
	public static function removeAccent($str)
	{
		$unicode = array(
			'a' => 'A|Á|À|Ả|Ã|Ạ|Ă|Ắ|Ằ|Ẳ|Ẵ|Ặ|Â|Ấ|Ầ|Ẩ|Ẫ|Ậ|á|à|ả|ã|ạ|ă|ắ|ằ|ẳ|ẵ|ặ|â|ấ|ầ|ẩ|ẫ|ậ',
			'b' =>  'B',
			'c' =>  'C',
			'd' => 'D|Đ|đ',
			'e' => 'E|É|È|Ẻ|Ẽ|Ẹ|Ê|Ế|Ề|Ể|Ễ|Ệ|é|è|ẻ|ẽ|ẹ|ê|ế|ề|ể|ễ|ệ',
			'f' => 'F',
			'g' => 'G',
			'h' => 'H',
			'i' => 'I|Í|Ì|Ỉ|Ĩ|Ị|í|ì|ỉ|ĩ|ị',
			'j' => 'J',
			'k' => 'K',
			'l' => 'L',
			'm' => 'M',
			'n' => 'N',
			'o' => 'O|Ó|Ò|Ỏ|Õ|Ọ|Ô|Ố|Ồ|Ổ|Ỗ|Ộ|Ơ|Ớ|Ờ|Ở|Ỡ|Ợ|ó|ò|ỏ|õ|ọ|ô|ố|ồ|ổ|ỗ|ộ|ơ|ớ|ờ|ở|ỡ|ợ',
			'p' => 'P',
			'q' => 'Q',
			'r' => 'R',
			's' => 'S',
			't' => 'T',
			'u' => 'U|Ú|Ù|Ủ|Ũ|Ụ|Ư|Ứ|Ừ|Ử|Ữ|Ự|ú|ù|ủ|ũ|ụ|ư|ứ|ừ|ử|ữ|ự',
			'v' => 'V',
			'w' => 'W',
			'x' => 'X',
			'y' => 'Y|Ý|Ỳ|Ỷ|Ỹ|Ỵ|ý|ỳ|ỷ|ỹ|ỵ',
			'z' => 'Z'
		);
		
		foreach($unicode as $nonUnicode => $uni) {
			$str = preg_replace("/($uni)/i", $nonUnicode, $str);
		}
		
		return $str;
	}
	
	/**
	 * Convert a string to slug format
	 *
	 * @param string $string
	 * @return string
	 */
	public static function getSlug ($string)
	{
		$string = self::removeAccent($string);
		$string = preg_replace('/[^a-zA-Z0-9]/i', '-', $string);
		$string = strtolower($string);
		$string = trim($string, '-');
		
		while (false !== strpos($string, '--')) {
			$string = str_replace('--', '-', $string);
		}
		
		return $string;
	}
	
	/**
	 * Generate a random string
	 *
	 * This method will generate a random string, 
	 * generated string will have length equals $length param 
	 * and contain char in $chars param
	 *
	 * @param int $length
	 * @param mixed $chars
	 * @return string
	 */
	public static function getRandom ($length, $chars = 'qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM1234567890')
	{
		$length = intval($length);
		if (empty($chars) OR $length <= 0) return '';
		
		$result = '';
		while (strlen($result) < $length) {
			$result.= $chars[mt_rand(0, strlen($chars) - 1)];
		}
		
		return $result;
	}
}
