<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: Controller.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
 
// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Controller exception
 *
 * @category	Exception
 * @author    Pham Thanh Binh <binhpham@netq.vn>
 */
class QControllerException extends Exception
{}

/**
 * This file is a part of QGallery project. 
 * It contain base controller with some common methods
 *
 * @category	Controller
 * @author    Pham Thanh Binh <binhpham@netq.vn>
 */
class QController extends JController
{
	// Save instance of model
	private $_loadedModels = array();
	
	/**
	 * Constructor method
	 *
	 * @param array $options
	 */
	public function __construct ($options = array()) 
	{
		parent::__construct($options);
		
		// Register task
		$this->registerTask('add', 'form');
		$this->registerTask('edit', 'form');
		$this->registerTask('save', 'form');
		$this->registerTask('apply', 'form');
		$this->registerTask('unpublish', 'publish');
		$this->registerLayout();
	}
	
	/**
	 * Setup layout, view for controller
	 *
	 * @return void
	 */
	protected function registerLayout ()
	{
		// Setting view for controller
		JRequest::setVar('view', JRequest::getVar('controller'));
		
		// Register layout based on task mapped
		if (isset($this->_taskMap[JRequest::getVar('task')])) {
			JRequest::setVar('layout', $this->_taskMap[JRequest::getVar('task')]);
		}
		else {
			JRequest::setVar('layout', JRequest::getVar('task', 'default'));
		}
	}
	
	/**
	 * Method for load instance of model
	 *
	 * @return nModel
	 */
	public function model ($name, $prefix = 'QGalleryModel')
	{
		return JModel::getInstance($name, $prefix);
	}
	
	/**
	 * Implement for cancel action
	 */
	public function cancel () 
	{
		$class = get_class($this);
		$controller = strtolower(str_replace('QGalleryController', '', $class));
		
		// Send redirect
		$this->setRedirect("index.php?option=com_qgallery&controller={$controller}");
	}
	
	/**
	 * Check a request is sent by XMLHttpRequest object
	 *
	 * @return bool
	 */
	public function isAjax ()
	{
		return (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest');
	}
}




