<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: View.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
 
// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Model exception
 *
 * @category	Exception
 * @author    	Pham Thanh Binh <binhpham@netq.vn>
 */
class QViewException extends Exception
{}

/**
 * This file is a part of QGallery project. 
 * It contain base view with some common methods
 *
 * @category	View
 * @author    	Pham Thanh Binh <binhpham@netq.vn>
 */
class QView extends JView
{
	/**
	 * Generate select box for filtering data by state
	 *
	 * @param string $nameOfControl
	 * @param string $selectedValue
	 *
	 * @return string
	 */
	protected function getStateFilter ($nameOfFilter, $selectedValue)
	{
		$states = array(
			array('value' => '', 'text' => '-- Select State --'),
			array('value' => 1,  'text' => 'Published'),
			array('value' => 0,  'text' => 'Unpublished')
		);
		
		return JHTML::_('select.genericlist', $states, "filters[{$nameOfFilter}]", 'class="filter"', 'value', 'text', $selectedValue);
	}
	
	/**
	 * Function for generate buttons
	 *
	 * @param array $buttons
	 * @return void
	 */
	protected function registerToolbar ($buttons)
	{
		if (is_array($buttons)) {
			foreach ($buttons as $key => $button) {
				if (!is_array($button)) {
					JToolBarHelper::$button();
				}
				else {
					$params = $button;
					$task   = (isset($params[0])) ? $params[0] : '';
					$icon   = (isset($params[1])) ? $params[1] : '';
					$iconOver = (isset($params[2])) ? $params[2] : $icon;
					$alt = (isset($params[3])) ? $params[3] : $task;
					$listSelect = (isset($params[4])) ? $params[4] : false;
					$x = (isset($params[5])) ? $params[5] : false;
					
					JToolBarHelper::custom($task, $icon, $iconOver, $alt, $listSelect, $x);
				}
			}
			
			JToolBarHelper::spacer(1);
		}
	}
	
	/**
	 * Print content when condition is true
	 *
	 * @param bool $condition
	 * @param string $content
	 *
	 * @return void
	 */
	public function printIf ($condition, $content) {
		if ($condition === true) echo $content;
	}
	
	/**
	 * Add javascript for handling filter form
	 *
	 * @return void
	 */
	protected function registerFilterScript ()
	{
		$document = JFactory::getDocument();
		$document->addScriptDeclaration("
			window.addEvent('domready', function () {
				$$('select.filter').addEvent('change', function () {
					\$E('form[name=adminForm]').submit();
				});
			});
		");
	}
}




