<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: pictures.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Album model
 *
 * @category	Model
 * @author		Pham Thanh Binh <binhpham@netq.vn>
 */
class QGalleryModelPictures extends QModel
{
	/**
	 * Retrieve single picture information
	 *
	 * @return mixed
	 */
	public function getData ()
	{
		$id = JRequest::getVar('id');
		
		$table = JTable::getInstance('Pictures', 'Table');
		$table->load($id);
		
		return $table->getProperties();
	}
	
	/**
	 * Remove one or more pictures
	 *
	 * @param array $ids
	 * @return array
	 */
	public function remove ($ids)
	{
		if (!is_array($ids)) {
			$ids = array($ids);
		}
		
		$table = JTable::getInstance('Pictures', 'Table');
		$deleted = 0;
		$skipped = 0;
		
		$path = JPATH_SITE.DS.'images'.DS.'com_qgallery';

		foreach ($ids as $id)
		{
			if (!is_numeric($id)) {
				continue;
			}
			
			$table->load($id);
			$table->deleted = 1;
			$table->store() ? $deleted++ : $skipped++;
		}
		
		return array($deleted, $skipped);
	}
	
	/**
	 * Return SQL string to query data
	 *
	 * @return string
	 */
	public function buildSQL ()
	{
		$albumId = JRequest::getVar('album');
		if (empty($albumId) || !is_numeric($albumId)) {
			return;
		}
		
		$filters = $this->getState('filters');
		
		$conditions = array();
		$conditions[] = "album_id={$albumId}";
		$conditions[] = "deleted=0";
		
		if (isset($filters['keyword']) && !empty($filters['keyword'])) {
			$conditions[] = "caption REGEXP '{$filters['keyword']}'";
		}
		
		if (isset($filters['state']) && is_numeric($filters['state'])) {
			$conditions[] = "published={$filters['state']}";
		}
		
		$orderBy = $this->getState('order_by');
		$orderDir = $this->getState('order_direction');
		$ordering = '';
		
		if (!empty($orderBy)) {
			$ordering.= "ORDER BY {$orderBy}";
			if (!empty($orderDir)) {
				$ordering.= " {$orderDir}";
			}
		}
		else {
			$ordering = "ORDER BY created ASC";
		}
		
		$query = "
			SELECT SQL_CALC_FOUND_ROWS * 
			FROM #__sg_pictures ".((!empty($conditions)) ? "
			WHERE ".implode(' AND ', $conditions) : '')." {$ordering}
		";
		
		return $query;
	}
}




