<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: albums.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Album Table
 *
 * @category	Table
 * @author		Pham Thanh Binh <binhpham@netq.vn>
 */
class TableAlbums extends JTable
{
	public $id;
	public $social_id;
	public $social_name;
	public $name;
	public $description;
	public $slug;
	public $cover_id;
	public $size;
	public $setting;
	public $last_updated;
	public $ordering;
	public $published;
	public $checked_out;
	public $checked_out_time;
	public $created;
	public $modified;
	
	public function __construct (&$db)
	{
		parent::__construct('#__sg_albums', 'id', $db);
		
		// Get default setting for album when new instance is created
		$this->setting = $this->getGlobalSetting();
	}
	
	/**
	 * Save binded data to table in database
	 *
	 * @return bool
	 */
	public function store () 
	{
		(empty($this->created)) ? $this->created = time() : $this->modified = time();
		
		if (empty($this->ordering)) {
			$this->_db->setQuery("SELECT MAX(ordering) FROM #__sg_albums LIMIT 1");
			$this->ordering = $this->_db->loadResult() + 1;
		}
		
		if (empty($this->setting)) {
			$this->setting = serialize($this->getGlobalSetting());
		}
		
		if (is_array($this->setting)) {
			$this->setting = serialize($this->setting);
		}
		
		if (empty($this->slug)) {
			$this->slug = StringHelper::getSlug($this->name);
		}

		return parent::store();
	}
	
	/**
	 * Retrieve global setting for album
	 *
	 * @return array
	 */
	private function getGlobalSetting ()
	{
		return array(
			'use_global' => true,
			'comment_enabled' => SettingHelper::get('comment_enabled'),
			'rating_enabled' => SettingHelper::get('rating_enabled'),
			'comment_per_page' => SettingHelper::get('comment_per_page'),
			'comment_delay_time' => SettingHelper::get('comment_delay_time'),
			'comment_require_login' => SettingHelper::get('comment_require_login'),
			'comment_enable_bbcode' => SettingHelper::get('comment_enable_bbcode'),
			'comment_enable_smilies' => SettingHelper::get('comment_enable_smilies'),
			'comment_enable_ajax' => SettingHelper::get('comment_enable_ajax'),
			'comment_enable_captcha' => SettingHelper::get('comment_enable_captcha'),
			'comment_sync' => SettingHelper::get('comment_sync'),
			'columns_per_page' => SettingHelper::get('columns_per_page'),
			'rows_per_page' => SettingHelper::get('rows_per_page'),
			'paginate_enable_ajax' => SettingHelper::get('paginate_enable_ajax'),
			'paginate_position' => SettingHelper::get('paginate_position')
		);
	}
	
	/**
	 * Retrieve single row from database determined by id
	 *
	 * @param int $id
	 */
	public function load ($id)
	{
		// Load data
		parent::load($id);
		
		if (empty($this->setting)) {
			$this->setting = $this->getGlobalSetting();
		}
		
		if (!is_array($this->setting)) {
			$this->setting = @unserialize($this->setting);
		}
	}
}




