<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: view.html.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * @category 	View
 * @author 		Pham Thanh Binh <binhpham@netq.vn>
 */
class QGalleryViewAlbums extends QView
{
	public function display ($tpl = null)
	{
		JHTML::_('behavior.modal');
		JHTML::stylesheet('style.css', 'administrator/components/com_qgallery/assets/');
		
		switch ($this->getLayout())
		{
			case 'form':	$this->_setupFormLayout();		break;
			case 'import':	$this->_setupImportLayout();	break;
			case 'pictures':$this->_setupPicturesLayout();	break;
			case 'social':	$this->_setupSocialLayout();	break;
			default:		$this->_setupDefaultLayout();	break;
		}
		
		parent::display($tpl);
	}
	
	/**
	 * Setup for display all album from social network
	 *
	 * @return void
	 */
	private function _setupSocialLayout ()
	{
		$this->assign('albums', FacebookHelper::getAlbums());
	}
	
	/**
	 * Preparing for render import album layout
	 *
	 * @return void
	 */
	private function _setupImportLayout ()
	{
		$this->assign('importCompleted', JRequest::getVar('importCompleted', false));
		$this->assign('data', JRequest::get('post'));
		$this->assign('socialAlbums', FacebookHelper::getAlbums());
		$this->assign('albums', $this->get('All'));
	}
	
	/**
	 * Preparing for render album detail layout
	 *
	 * @return void
	 */
	private function _setupPicturesLayout ()
	{
		// Title setting
		JRequest::setVar('cid', array(JRequest::getVar('album')));
		
		// Load album information
		$album = $this->get('Data');
		$this->assign('album', $album);
		
		JToolBarHelper::title(sprintf('QGallery [<small>Albums - %s</small>]', $album->name));
		
		// Toolbar buttons setting
		$this->registerToolbar(array('cancel'));
		
		// Register script for handling filter
		$this->registerFilterScript();
		
		// Set Pictures model to this view instead Albums model
		$this->setModel(JModel::getInstance('Pictures', 'QGalleryModel'), true);
		
		// Retrieve filters from model
		$filters = $this->get('Filters');
		
		$this->assign('order', $this->get('OrderOptions'));
		$this->assign('filters', $filters);
		$this->assign('pictures', $this->get('List'));
		$this->assign('paginate', $this->get('Paginate'));
		$this->assign('states', $this->getStateFilter('state', $filters['state']));
	}
	
	/**
	 * Setting title, buttons on toolbar for default layout
	 *
	 * @return void
	 */
	private function _setupDefaultLayout ()
	{
		// Title setting
		JToolBarHelper::title('QGallery [<small>Albums</small>]');
		
		// Toolbar buttons setting
		$this->registerToolbar(array(
			'addNew', 'import' => array('import', 'import', '', 'Import'), 'publishList', 'unpublishList', 'editList', 'deleteList'
		));
		
		// Register script for handling filter
		$this->registerFilterScript();
		
		// Retrieve filters from model
		$filters = $this->get('Filters');

		$this->assign('order', $this->get('OrderOptions'));
		$this->assign('filters', $filters);
		$this->assign('albums', $this->get('List'));
		$this->assign('paginate', $this->get('Paginate'));
		$this->assign('states', $this->getStateFilter('state', @$filters['state']));
	}
	
	/**
	 * This method same as _setupDefaultLayout, but it implement for add layout
	 *
	 * @return void
	 */
	private function _setupFormLayout ()
	{
		jimport('joomla.html.pane');

		$cid = JRequest::getVar('cid');
		$title = (!empty($cid)) ? 'Edit Album' : 'Add Album';
		
		// Title setting
		JToolBarHelper::title("QGallery [<small>Albums - {$title}</small>]");
		$this->registerToolbar(array('save', 'apply', 'cancel'));
		
		$document = JFactory::getDocument();
		$document->addScriptDeclaration("
			function setSocialAlbumInfo (id, name) {
				$('social_name').setProperty('value', name);
				$('social_id').setProperty('value', id);
				$('sbox-window').close();
			}
		");
		
		// Load existed data for passing to view
		$data = $this->get('Data');
		
		// Add positions to view
		$this->assign('positions', $this->_getPositionOptions());
		
		// Add JPanel instance to view
		$this->assign('pane', JPane::getInstance('tabs'));
		$this->assign('editorParams', array('smilies'=> '0', 'style' => '1', 'layer' => '0', 'table' => '0', 'clear_entities' => '0'));
		$this->assign('editor', JFactory::getEditor());
		$this->assign('data', $data);
		
		// Load mootools by default
		JHTML::_('behavior.mootools');
		JHTML::_('behavior.modal');
	}
	
	/**
	 * Retrieve data to filling to select box for configure pagination position
	 *
	 * @return string
	 */
	private function _getPositionOptions ()
	{
		// Pagination position options
		$positions = array();
		$positions[] = array('value' => '', 'text' => '-- Select --');
		$positions[] = array('value' => 'top', 'text' => 'Top');
		$positions[] = array('value' => 'bottom', 'text' => 'Bottom');
		$positions[] = array('value' => 'both', 'text' => 'Both');
		
		return $positions;
	}
}





