<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: albums.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Album model
 *
 * @category	Model
 * @author		Pham Thanh Binh <binhpham@netq.vn>
 */
class QGalleryModelAlbums extends QModel
{
	/**
	 * Override constructor method of QModel
	 *
	 * @return void
	 */
	public function __construct ()
	{
		parent::__construct();
		
		// Set pagination limit
		$this->setState('limit', SettingHelper::get('rows_per_page') * SettingHelper::get('columns_per_page'));
	}
	
	/**
	 * Retrieve row by specified id
	 *
	 * @param int $id
	 * @return JTable
	 */
	public function getData ($id = null)
	{
		$table = JTable::getInstance('Albums', 'Table');
		$ids = JRequest::getVar('cid');
		
		if ($id === null && !empty($ids)) {
			$id = (is_array($ids)) ? array_shift($ids) : intval($ids);
		}
		
		if ($id > 0) {
			$table->load($id);
		}
		
		return $table;
	}
	
	/**
	 * Helper method to generate SQL for fetching data
	 *
	 * @return string
	 */
	protected function buildSQL ()
	{
		$filters = $this->getState('filters');
		
		// Conditions use for filtering data
		$conditions = array();
		$conditions[] = 'a.published=1';
		
		$query = "
			SELECT SQL_CALC_FOUND_ROWS a.*, p.src_small 
				FROM #__sg_albums a 
				LEFT JOIN #__sg_pictures p ON a.cover_id=p.id
			".((!empty($conditions)) ? "
			WHERE ".implode(' AND ', $conditions) : '')." ORDER BY a.created ASC
		";
		
		// Return SQL
		return $query;
	}
}




