<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: pictures.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Album model
 *
 * @category	Model
 * @author		Pham Thanh Binh <binhpham@netq.vn>
 */
class QGalleryModelPictures extends QModel
{
	/**
	 * Override constructor method
	 *
	 * @return void
	 */
	public function __construct ()
	{
		parent::__construct();
		
		$albumId = JRequest::getVar('id');
		if (false !== strpos($albumId, ':')) {
			$albumId = substr($albumId, 0, strpos($albumId, ':'));
		}
		
		$album = JTable::getInstance('Albums', 'Table');
		$album->load($albumId);
		
		$this->setState('album', $album);
		$this->setState('albumId', $albumId);
		$this->setState('limit', $album->setting['rows_per_page'] * $album->setting['columns_per_page']);
	}
	
	/**
	 * Update album, pictures from facebook
	 *
	 * @return void
	 */
	public function update ()
	{
		$expiredTime = time() - 60;
		
		// Load album is needed to update
		$this->_db->setQuery("SELECT social_id FROM #__sg_albums WHERE modified <= {$expiredTime}");
		$socialIds = $this->_db->loadResultArray();
		$aids = implode("', '", $socialIds);
		
		if (!empty($socialIds))
		{
			try {
				// Get facebook client
				require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'facebook.php';
				
				$client = FacebookHelper::getFacebookClient();
				$pictures = $client->api(array(
					'method' => 'fql.query',
					'query'  => "SELECT pid, aid, src, src_big, caption, created FROM photo WHERE aid IN ('{$aids}')"
				));
				
				foreach ($socialIds as $albumSocialId)
				{
					$this->_db->setQuery("SELECT * FROM #__sg_albums WHERE social_id LIKE '{$albumSocialId}'");
					$albums = $this->_db->loadObjectList();
					
					foreach ($albums as $album) 
					{					
						foreach ($pictures as $pic)
						{
							if ($pic['aid'] == $albumSocialId) 
							{
								if (!$this->pictureExist($pic['pid'], $album->id))
								{
									$table = JTable::getInstance('Pictures', 'Table');
									$table->album_id = $album->id;
									$table->album_name = $album->name;
									$table->caption = $pic['caption'];
									$table->social_id = $pic['pid'];
									$table->src = $pic['src_big'];
									$table->src_small = $pic['src'];
									$table->published = 1;
									$table->created = $pic['created'];
									$table->store();
								}
							}
						}
						
						$this->_db->setQuery("UPDATE #__sg_albums SET modified=UNIX_TIMESTAMP(), size=(SELECT COUNT(*) FROM #__sg_pictures WHERE album_id={$album->id}) WHERE id={$album->id}");
						$this->_db->query();
					}
				}
			}
			catch (Exception $ex) {
				echo $ex->getMessage();
			}
		}
	}
	
	/**
	 * Check picture is existed in album by social ID
	 *
	 * @param string $id
	 * @param int $albumId
	 *
	 * @return bool
	 */
	public function pictureExist ($id, $albumId)
	{
		$this->_db->setQuery("SELECT COUNT(*) FROM #__sg_pictures WHERE social_id LIKE '{$id}' AND album_id={$albumId} LIMIT 1");
		return (0 < intval($this->_db->loadResult()));
	}
	
	/**
	 * Retrieve album information
	 *
	 * @return object
	 */
	public function getAlbum ()
	{
		return $this->getState('album');
	}
	
	/**
	 * Retrieve single picture information
	 *
	 * @return mixed
	 */
	public function getData ()
	{
		$id = JRequest::getVar('id');
		
		$table = JTable::getInstance('Pictures', 'Table');
		$table->load($id);
		
		return $table->getProperties();
	}
	
	/**
	 * Return SQL string to query data
	 *
	 * @return string
	 */
	public function buildSQL ()
	{
		$albumId = $this->getState('albumId');
		if (empty($albumId) || !is_numeric($albumId)) {
			return;
		}
		
		$conditions = array();
		$conditions[] = "album_id={$albumId}";
		$conditions[] = "deleted=0";
		$conditions[] = "published=1";
		
		$ordering = "ORDER BY created ASC";
		$query = "
			SELECT SQL_CALC_FOUND_ROWS * 
			FROM #__sg_pictures ".((!empty($conditions)) ? "
			WHERE ".implode(' AND ', $conditions) : '')." {$ordering}
		";
		
		return $query;
	}
}




