<?php
/**
 * @package Component Facebook Gallry for Joomla! 1.5
 * @version $Id: view.base.php 599 2010-11-12 23:26:33Z trungdt $
 * @author NETQ CREATIVE SOFTWARE (service@netqcreative.com)
 * @copyright (C) 2010- NETQ CREATIVE SOLUTION
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

// No direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Base class for default view
 *
 * @category	View
 * @author		Pham Thanh Binh <binhpham@netq.vn>
 */
class QGalleryViewDefaultBase extends QView
{
	public function display ($tpl = null)
	{
		// Add script to execute update url
		$updateUrl = JRoute::_('index.php?option=com_qgallery&layout=update');
		
		$document = JFactory::getDocument();
		$document->addScriptDeclaration("
			window.addEvent('domready', function () {
				setInterval(function () {
					new Ajax('{$updateUrl}').request();
				}, 60000);
			});
		");
		
		// Set default model for view
		$this->setModel(JModel::getInstance('Albums', 'QGalleryModel'), true);
		
		// Add script for handle ajax
		if (SettingHelper::get('paginate_enable_ajax') == 1 && !QController::isAjax()) {
			JHTML::script('ajax.js', 'components/com_qgallery/assets/');
		}
		
		// Setup data for layout
		switch ($this->getLayout()) {
			case 'album': $this->_setupAlbumLayout(); break;
			default: $this->_setupDefaultLayout(); break;
		}
		
		// Render template
		parent::display($tpl);
	}
	
	/**
	 * Preparing data for album layout
	 *
	 * @return void
	 */
	public function _setupAlbumLayout ()
	{
		$this->setModel(JModel::getInstance('Pictures', 'QGalleryModel'), true);
		
		$album    = $this->get('Album');
		
		if ($album->published == 0) {
			$this->setLayout('denied');
			return;
		}
		
		$pictures = $this->get('List');
		$paginate = $this->get('Paginate');
		
		$paginate->showInTop = in_array($album->setting['paginate_position'], array('both', 'top'));
		$paginate->showInBottom = in_array($album->setting['paginate_position'], array('both', 'bottom'));
		
		$this->assign('album', $album);
		$this->assign('pictures', $pictures);
		$this->assign('paginate', $paginate);
	}
	
	/**
	 * Setting up for default layout
	 *
	 * @return void
	 */
	private function _setupDefaultLayout ()
	{
		$albums = $this->get('List');
		foreach ($albums as &$album) {
			$album->setting = unserialize($album->setting);
		}
		
		$paginate = $this->get('Paginate');
		$paginate->showInTop = in_array(SettingHelper::get('paginate_position'), array('both', 'top'));
		$paginate->showInBottom = in_array(SettingHelper::get('paginate_position'), array('both', 'bottom'));
		
		$this->assign('albums', $albums);
		$this->assign('paginate', $paginate);
	}
}